/*  cli.c */
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include <string.h>
#include <strings.h>
#include <unistd.h>
#include <stdlib.h>

main(int argc, char *argv[])
{
    int sock, rrep;
    struct sockaddr_in server;
    struct hostent *hp;
    char cmdline[60], replybuf[1024];
    char buf1[20], buf2[20], buf3[20];

    /* make sure we have required number of command line arguments */
    if(argc<3)
    {
        printf("Usage: ./ns-cli servermachinename portnumber\n");
        exit(-1);
    }

    /* set up the remote server address structure (ip + pport) */
    server.sin_family=AF_INET;
    hp=gethostbyname(argv[1]);
    if(hp==0)
    {
        fprintf(stderr, "%s:unknown host",argv[1]);
        exit(-1);
    }
    
    bcopy(hp->h_addr, &server.sin_addr, hp->h_length);
    server.sin_port=htons(atoi(argv[2]));

    /* create a socket on local (client) machine and get its descriptor */
    sock=socket(AF_INET, SOCK_STREAM, 0);
    if(sock<0)
    {
        perror("opeining stream socket");
        exit(-1);
    }
        
    /* connect to the server through the socket */
    if(connect(sock, (struct sockaddr*)&server, sizeof(server))<0)
    {
        perror("connecting stream socket");
        exit(-1);
    }   

    /* read from keyboard, send to server, receive response, print response */
    for(;;)
    {
        printf("> ");     
        gets(cmdline);
        
	/* get the three first words that were typed (we will use only one)*/
        sscanf(cmdline,"%s %s %s", buf1, buf2, buf3);

        /* send to the server the contents of cmdline */
        if (write(sock, cmdline, sizeof(cmdline))<0)
            perror("writing on stream socket"); 

	/* check if instructed to quit the program */
        if(strcmp(buf1,"die")== NULL)
        {
            close(sock);
            exit(0);
        }
        
	/* receive server response and place it in the reply buffer */ 
        bzero(replybuf, sizeof(replybuf));
        if((rrep=read(sock,replybuf,1024)) < 0)
            perror("reading reply message");
            
	/* print to the screen what was received */
        if(rrep==0)
            printf("Ending receiving reply\n");
        else
            printf("\n==>%s\n\n",replybuf);
        
    } /* for */
    
}


