/* svr.c */
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <strings.h>
#include <string.h>
#include <unistd.h>
#include <stdio.h>



main()
{
    int rval, clilen, length;
    int nready, client[FD_SETSIZE];
    int i, maxi, maxfd, listenfd, connfd, sockfd;
    fd_set rset, allset;
    struct sockaddr_in cliaddr, server;
    char buf[60], buf1[20], buf2[20], buf3[20];

    /* create a socket through which requests are received */
    listenfd=socket(AF_INET, SOCK_STREAM, 0);
    if(listenfd<0)
    {
        perror("opeining stream socket");
        exit(-1);
    }

    /* create own address at which the server provides the service */
    server.sin_family      = AF_INET;
    server.sin_addr.s_addr = INADDR_ANY; /*automatically fill server IP addr */
    server.sin_port        = 0;       /* 0 means "give me any available port */
    if(bind(listenfd, (struct sockaddr*)&server, sizeof(server)))
    {
        perror("binding stream socket");
        exit(-1);
    }

    /* now let's see what port  number the server was assigned */
    length=sizeof(server);
    if(getsockname(listenfd, (struct sockaddr*)&server, &length))
    {
        perror("getting socket name");
        exit(-1);
    }
    printf("Socket has port #%d\n",ntohs(server.sin_port));

    /* allow up to 1024 clients serviced at the same time */
    listen(listenfd, 1024);

    /* prepare the parameters for the select() call later */
    maxfd = listenfd;            /* initialize */
    maxi = -1;                    /* index into client[] array */
    for (i = 0; i < FD_SETSIZE; i++)
        client[i] = -1;            /* -1 indicates available entry */
    FD_ZERO(&allset);
    FD_SET(listenfd, &allset);
    
    for(;;)
    {
        rset = allset;
	/* wait for any activity on the socket */
        nready = select(maxfd+1, &rset, NULL, NULL, NULL);

        if(FD_ISSET(listenfd, &rset)) {    /* new client connection */
            clilen = sizeof(cliaddr);

            /* accept the connection from the client and get its address*/
            connfd=accept(listenfd, (struct sockaddr*)&cliaddr, &clilen);    
            if(connfd==-1)
            {
                perror("accept");
                exit(-1);
            }

	    /* look through our placeholders for sockets connecting
	     * the server to different clients, and save connection
	     * descriptor (socket) to new client */
            for (i = 0; i < FD_SETSIZE; i++)
                if (client[i] < 0) {
                    client[i] = connfd;    /* save descriptor */
                    break;
                }
            
            if (i == FD_SETSIZE)
            {
                perror("too many clients");
                exit(-1);
            }

            FD_SET(connfd, &allset);    /* add new descriptor to set */
            if (connfd > maxfd)
                maxfd = connfd;            /* for select */
            if (i > maxi)
                maxi = i;                /* max index in client[] array */

            if (--nready <= 0)
                continue;                   /* no more readable descriptors */
        }

        for (i = 0; i <= maxi; i++) {    /* check all clients for data */
            if ( (sockfd = client[i]) < 0)
                continue;
            if (FD_ISSET(sockfd, &rset)) {
	        if((rval=read(sockfd, buf, 60))<0) /* receive data */
                {
                    perror("reading stream message");
                    exit(-1);
                }
                    
		/* if one of the clients closed the connection */
                if(rval==0)
                {
                    fprintf(stderr,"Ending connection\n");
                    close(sockfd);
                    FD_CLR(sockfd, &allset);
                    client[i] = -1;
                }                    
                else
                {
                    fprintf(stderr,"--> %s\n",buf);
                    sscanf(buf, "%s %s %s", buf1, buf2, buf3);
 
		    /* check if this is a request to quit */
                    if(strcmp(buf1, "die")==NULL)
                    {
                        close(connfd);
                        /* close(listenfd);*/ 
                        exit(0); 
                    }
		    
		    /* reply to the client request */
                    if (write(sockfd, buf, rval)<0)
                        perror("writing on stream socket");  
                }

                if (--nready <= 0)
                    break;                /* no more readable descriptors */

                bzero(buf, sizeof(buf));
            }
        }            
    }
}
